#  Extspell

#  Copyright (C) 2004-2007, Marc Prior

#  This program is free software; you may redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License (GPL) for more details.
#
#  A copy of the GNU General Public License should be available from
#  the source from which you obtained this program; if not, write
#  to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
#  Boston, MA  02111-1307  USA
#
#  Marc Prior
#  lin4trans@users.sourceforge.net
#  www.marcprior.de
#
#  Extspell and other OmegaTk applications are subject to
#  ABSOLUTELY NO WARRANTY
#  This is free software, and you are welcome to redistribute it
#  under certain conditions; please refer to the GPL for details

source defaults.tcl
defaults

global seltype
global textlock
global mlock
global dictcode
global selhandler

set textlock off
set dictlist [exec aspell dump dicts]

frame .fr
frame .fr.mbar
pack .fr.mbar -side top -fill x

if {$selhandler == 1} then {
menubutton .fr.mbar.sel -text {Selection} -menu .fr.mbar.sel.menu
set msel [menu .fr.mbar.sel.menu -tearoff 1]
$msel add radio -label Clipboard -variable seltype -value CLIPBOARD
$msel add radio -label Primary -variable seltype -value PRIMARY
pack .fr.mbar.sel -side left
}

menubutton .fr.mbar.lock -text {Lock} -menu .fr.mbar.lock.menu
set mlock [menu .fr.mbar.lock.menu -tearoff 1]
$mlock add radio -label {Lock selection} -variable textlock -value on
$mlock add radio -label {Unlock selection} -variable textlock -value off

menubutton .fr.mbar.lang -text {Language} -menu .fr.mbar.lang.menu
set mlang [menu .fr.mbar.lang.menu -tearoff 1]
foreach dict $dictlist {
$mlang add radio -label $dict -variable dictcode -value $dict
}

pack .fr.mbar.lock -side left
pack .fr.mbar.lang -side left

scrollbar .fr.yscroll -command {.fr.t yview}
text .fr.t -width 80 -height 20 -bg white -yscrollcommand {.fr.yscroll set}
pack .fr -expand true -fill both
.fr.t tag configure highlight -background $highlighting
pack .fr.yscroll -side right -fill y
pack .fr.t -expand true -fill both

bind .fr.t <FocusIn> "insertCB"

proc insertCB { } {

global seltype
global textlock
global dictcode
global highlighting

if {$textlock == on} { 
return 
} else {

.fr.t delete 1.0 end

catch {set stringCB [selection get -selection $seltype -type UTF8_STRING] }
.fr.t insert 1.0 $stringCB

set aspellOut [exec aspell --lang=$dictcode list << $stringCB]

foreach wordSP $aspellOut {
set iSP [regsub -all $wordSP $stringCB $wordSP $stringCB]
set startix 1.0

for {set i 0} {$i < $iSP} {incr i} {
set ixWordSP [.fr.t search -count cntWordSP -regexp $wordSP $startix end]
.fr.t tag add highlight $ixWordSP "$ixWordSP +$cntWordSP chars"
set startix "$ixWordSP +$cntWordSP chars"
	 		}
		}
	}

}
